osgViewer::InteractiveImageHandler Class Reference

`#include <ViewerEventHandlers>`

Inheritance diagram for osgViewer::InteractiveImageHandler:

## Public Member Functions

| InteractiveImageHandler (osg::Image *image)
| Constructor to use when the InteractiveImage is in the 3D scene (i.e. not in a fullscreen HUD overlay).
| InteractiveImageHandler (osg::Image *image, osg::Texture2D *texture, osg::Camera *camera)
| Constructor to use when the InteractiveImage is in a fullscreen HUD overlay.
| META_Object (osgViewer, InteractiveImageHandler)
virtual NodeCallback * | asNodeCallback ()
virtual const NodeCallback * | asNodeCallback () const
virtual DrawableEventCallback * | asDrawableEventCallback ()
virtual const DrawableEventCallback * | asDrawableEventCallback () const
virtual DrawableCullCallback * | asDrawableCullCallback ()
virtual const DrawableCullCallback * | asDrawableCullCallback () const
virtual osgGA::EventHandler * | asEventHandler ()
virtual const osgGA::EventHandler * | asEventHandler () const
virtual bool | run (osg::Object *object, osg::Object *data)
virtual bool | handle (const osgGA::GUIEventAdapter &ea, osgGA::GUIActionAdapter &aa, osg::Object *, osg::NodeVisitor *nv)
virtual bool | cull (osg::NodeVisitor *nv, osg::Drawable *drawable, osg::RenderInfo *renderInfo) const
Public Member Functions inherited from osgGA::GUIEventHandler
| GUIEventHandler ()
| GUIEventHandler (const GUIEventHandler &eh, const osg::CopyOp &copyop=osg::CopyOp::SHALLOW_COPY)
| META_Object (osgGA, GUIEventHandler)
virtual bool | handle (osgGA::Event *event, osg::Object *object, osg::NodeVisitor *nv)
virtual bool | handle (const GUIEventAdapter &, GUIActionAdapter &)
Public Member Functions inherited from osgGA::EventHandler
| EventHandler ()
| EventHandler (const EventHandler &eh, const osg::CopyOp &copyop=osg::CopyOp::SHALLOW_COPY)
| META_Object (osgGA, EventHandler)
virtual void | operator() (osg::Node *node, osg::NodeVisitor *nv)
virtual void | event (osg::NodeVisitor *nv, osg::Drawable *drawable)
virtual void | getUsage (osg::ApplicationUsage &) const
Public Member Functions inherited from osg::NodeCallback
| NodeCallback ()
| NodeCallback (const NodeCallback &nc, const CopyOp &copyop)
| META_Object (osg, NodeCallback)
Public Member Functions inherited from osg::Callback
| Callback ()
| Callback (const Callback &cb, const CopyOp &copyop)
| META_Object (osg, Callback)
virtual Callback * | asCallback ()
virtual const Callback * | asCallback () const
virtual CallbackObject * | asCallbackObject ()
virtual const CallbackObject * | asCallbackObject () const
virtual StateAttributeCallback * | asStateAttributeCallback ()
virtual const StateAttributeCallback * | asStateAttributeCallback () const
virtual UniformCallback * | asUniformCallback ()
virtual const UniformCallback * | asUniformCallback () const
virtual DrawableUpdateCallback * | asDrawableUpdateCallback ()
virtual const DrawableUpdateCallback * | asDrawableUpdateCallback () const
bool | traverse (osg::Object *object, osg::Object *data)
void | setNestedCallback (osg::Callback *cb)
osg::Callback * | getNestedCallback ()
const osg::Callback * | getNestedCallback () const
void | addNestedCallback (osg::Callback *nc)
void | removeNestedCallback (osg::Callback *nc)
Public Member Functions inherited from osg::Object
| Object ()
| Object (bool threadSafeRefUnref)
| Object (const Object &, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
virtual Object * | cloneType () const =0
virtual Object * | clone (const CopyOp &) const =0
virtual bool | isSameKindAs (const Object *) const
virtual const char * | libraryName () const =0
virtual const char * | className () const =0
std::string | getCompoundClassName () const
virtual Node * | asNode ()
virtual const Node * | asNode () const
virtual NodeVisitor * | asNodeVisitor ()
virtual const NodeVisitor * | asNodeVisitor () const
virtual StateSet * | asStateSet ()
virtual const StateSet * | asStateSet () const
virtual StateAttribute * | asStateAttribute ()
virtual const StateAttribute * | asStateAttribute () const
virtual Uniform * | asUniform ()
virtual const Uniform * | asUniform () const
virtual Camera * | asCamera ()
virtual const Camera * | asCamera () const
virtual Drawable * | asDrawable ()
virtual const Drawable * | asDrawable () const
virtual UserDataContainer * | asUserDataContainer ()
virtual const UserDataContainer * | asUserDataContainer () const
virtual ValueObject * | asValueObject ()
virtual const ValueObject * | asValueObject () const
virtual Image * | asImage ()
virtual const Image * | asImage () const
virtual void | setThreadSafeRefUnref (bool threadSafe)
virtual void | setName (const std::string &name)
void | setName (const char *name)
const std::string & | getName () const
void | setDataVariance (DataVariance dv)
DataVariance | getDataVariance () const
virtual void | computeDataVariance ()
void | setUserDataContainer (osg::UserDataContainer *udc)
template<class T>
void | setUserDataContainer (const ref_ptr< T > &udc)
osg::UserDataContainer * | getUserDataContainer ()
const osg::UserDataContainer * | getUserDataContainer () const
osg::UserDataContainer * | getOrCreateUserDataContainer ()
virtual void | setUserData (Referenced *obj)
template<class T>
void | setUserData (const ref_ptr< T > &ud)
virtual Referenced * | getUserData ()
virtual const Referenced * | getUserData () const
template<typename T>
bool | getUserValue (const std::string &name, T &value) const
template<typename T>
void | setUserValue (const std::string &name, const T &value)
virtual void | resizeGLObjectBuffers (unsigned int)
virtual void | releaseGLObjects (osg::State *=0) const
template<typename T>
BoolValueObject UCharValueObject UShortValueObject UIntValueObject DoubleValueObject Vec3fValueObject Vec2dValueObject Vec4dValueObject PlaneValueObject MatrixdValueObject BoundingBoxdValueObject BoundingSpheredValueObject bool | getUserValue (const std::string &name, T &value) const
Public Member Functions inherited from osg::Referenced
| Referenced ()
| Referenced (bool threadSafeRefUnref)
| Referenced (const Referenced &)
Referenced & | operator= (const Referenced &)
bool | getThreadSafeRefUnref () const
OpenThreads::Mutex * | getRefMutex () const
int | ref () const
int | unref () const
int | unref_nodelete () const
int | referenceCount () const
ObserverSet * | getObserverSet () const
ObserverSet * | getOrCreateObserverSet () const
void | addObserver (Observer *observer) const
void | removeObserver (Observer *observer) const
Public Member Functions inherited from osg::DrawableEventCallback
| DrawableEventCallback ()
| DrawableEventCallback (const DrawableEventCallback &org, const CopyOp &copyop)
| META_Object (osg, DrawableEventCallback)
Public Member Functions inherited from osg::DrawableCullCallback
| DrawableCullCallback ()
| DrawableCullCallback (const DrawableCullCallback &org, const CopyOp &copyop)
| META_Object (osg, DrawableCullCallback)
virtual bool | cull (osg::NodeVisitor *, osg::Drawable *, osg::State *) const

## Protected Member Functions

virtual | ~InteractiveImageHandler ()
| InteractiveImageHandler ()
| InteractiveImageHandler (const InteractiveImageHandler &, const osg::CopyOp &=osg::CopyOp::SHALLOW_COPY)
bool | mousePosition (osgViewer::View *view, osg::NodeVisitor *nv, const osgGA::GUIEventAdapter &ea, int &x, int &y) const
void | resize (int width, int height)
Protected Member Functions inherited from osgGA::GUIEventHandler
virtual | ~GUIEventHandler ()
Protected Member Functions inherited from osg::NodeCallback
virtual | ~NodeCallback ()
Protected Member Functions inherited from osg::Callback
virtual | ~Callback ()
Protected Member Functions inherited from osg::Object
virtual | ~Object ()
Protected Member Functions inherited from osg::Referenced
virtual | ~Referenced ()
void | signalObserversAndDelete (bool signalDelete, bool doDelete) const
void | deleteUsingDeleteHandler () const

## Protected Attributes

osg::observer_ptr< osg::Image > | _image
osg::observer_ptr< osg::Texture2D > | _texture
bool | _fullscreen
osg::observer_ptr< osg::Camera > | _camera
Protected Attributes inherited from osg::Callback
ref_ptr< Callback > | _nestedCallback
Protected Attributes inherited from osg::Object
std::string | _name
DataVariance | _dataVariance
osg::UserDataContainer * | _userDataContainer
Protected Attributes inherited from osg::Referenced
OpenThreads::AtomicPtr | _observerSet
OpenThreads::Atomic | _refCount

## Additional Inherited Members

Public Types inherited from osg::Object
enum | DataVariance { DYNAMIC , STATIC , UNSPECIFIED }
Static Public Member Functions inherited from osg::Referenced
static OpenThreads::Mutex * | getGlobalReferencedMutex ()
static void | setDeleteHandler (DeleteHandler *handler)
static DeleteHandler * | getDeleteHandler ()

## Detailed Description

InteractiveImage is an event handler that computes the mouse coordinates in an images coordinate frame and then passes keyboard and mouse events to it. This event handler is useful for vnc or browser surfaces in the 3D scene.

## Constructor & Destructor Documentation

## InteractiveImageHandler() [1/4]

osgViewer::InteractiveImageHandler::InteractiveImageHandler | ( | osg::Image * | image | ) |

Constructor to use when the InteractiveImage is in the 3D scene (i.e. not in a fullscreen HUD overlay).

Referenced by InteractiveImageHandler(), and META_Object().

## InteractiveImageHandler() [2/4]

osgViewer::InteractiveImageHandler::InteractiveImageHandler | ( | osg::Image * | image,
|  | osg::Texture2D * | texture,
|  | osg::Camera * | camera )

Constructor to use when the InteractiveImage is in a fullscreen HUD overlay.

## ~InteractiveImageHandler()

virtual osgViewer::InteractiveImageHandler::~InteractiveImageHandler | ( |  | ) |

inline protected virtual

## InteractiveImageHandler() [3/4]

osgViewer::InteractiveImageHandler::InteractiveImageHandler | ( |  | ) |

inline protected

References _fullscreen.

## InteractiveImageHandler() [4/4]

osgViewer::InteractiveImageHandler::InteractiveImageHandler | ( | const InteractiveImageHandler & | ,
|  | const osg::CopyOp & | = osg::CopyOp::SHALLOW_COPY )

inline protected

References _fullscreen, osg::Callback::Callback(), osg::DrawableCullCallback::DrawableCullCallback(), osgGA::GUIEventHandler::GUIEventHandler(), InteractiveImageHandler(), osg::Object::Object(), and osg::CopyOp::SHALLOW_COPY.

## Member Function Documentation

## asDrawableCullCallback() [1/2]

virtual DrawableCullCallback * osgViewer::InteractiveImageHandler::asDrawableCullCallback | ( |  | ) |

inline virtual

Reimplemented from osg::Callback.

References osg::DrawableCullCallback::asDrawableCullCallback(), and osg::DrawableCullCallback::DrawableCullCallback().

## asDrawableCullCallback() [2/2]

virtual const DrawableCullCallback * osgViewer::InteractiveImageHandler::asDrawableCullCallback | ( |  | ) | const

inline virtual

Reimplemented from osg::Callback.

References osg::DrawableCullCallback::asDrawableCullCallback(), and osg::DrawableCullCallback::DrawableCullCallback().

## asDrawableEventCallback() [1/2]

virtual DrawableEventCallback * osgViewer::InteractiveImageHandler::asDrawableEventCallback | ( |  | ) |

inline virtual

Reimplemented from osgGA::EventHandler.

References osg::DrawableEventCallback::asDrawableEventCallback(), and osg::DrawableEventCallback::DrawableEventCallback().

## asDrawableEventCallback() [2/2]

virtual const DrawableEventCallback * osgViewer::InteractiveImageHandler::asDrawableEventCallback | ( |  | ) | const

inline virtual

Reimplemented from osgGA::EventHandler.

References osg::DrawableEventCallback::asDrawableEventCallback(), and osg::DrawableEventCallback::DrawableEventCallback().

## asEventHandler() [1/2]

virtual osgGA::EventHandler * osgViewer::InteractiveImageHandler::asEventHandler | ( |  | ) |

inline virtual

Reimplemented from osgGA::EventHandler.

References osgGA::EventHandler::asEventHandler().

## asEventHandler() [2/2]

virtual const osgGA::EventHandler * osgViewer::InteractiveImageHandler::asEventHandler | ( |  | ) | const

inline virtual

Reimplemented from osgGA::EventHandler.

References osgGA::EventHandler::asEventHandler().

## asNodeCallback() [1/2]

virtual NodeCallback * osgViewer::InteractiveImageHandler::asNodeCallback | ( |  | ) |

inline virtual

Reimplemented from osgGA::EventHandler.

References osg::NodeCallback::asNodeCallback(), and osg::NodeCallback::NodeCallback().

## asNodeCallback() [2/2]

virtual const NodeCallback * osgViewer::InteractiveImageHandler::asNodeCallback | ( |  | ) | const

inline virtual

Reimplemented from osgGA::EventHandler.

References osg::NodeCallback::asNodeCallback(), and osg::NodeCallback::NodeCallback().

## cull()

virtual bool osgViewer::InteractiveImageHandler::cull | ( | osg::NodeVisitor * | nv,
|  | osg::Drawable * | drawable,
|  | osg::RenderInfo * | renderInfo ) const

virtual

do customized cull code, return true if drawable should be culled.

Reimplemented from osg::DrawableCullCallback.

## handle()

virtual bool osgViewer::InteractiveImageHandler::handle | ( | const osgGA::GUIEventAdapter & | ea,
|  | osgGA::GUIActionAdapter & | aa,
|  | osg::Object * | ,
|  | osg::NodeVisitor * | )

virtual

Handle events, return true if handled, false otherwise.

Reimplemented from osgGA::GUIEventHandler.

## META_Object()

osgViewer::InteractiveImageHandler::META_Object | ( | osgViewer | ,
|  | InteractiveImageHandler | )

References InteractiveImageHandler().

## mousePosition()

bool osgViewer::InteractiveImageHandler::mousePosition | ( | osgViewer::View * | view,
|  | osg::NodeVisitor * | nv,
|  | const osgGA::GUIEventAdapter & | ea,
|  | int & | x,
|  | int & | y ) const

protected

## resize()

void osgViewer::InteractiveImageHandler::resize | ( | int | width,
|  | int | height )

protected

## run()

virtual bool osgViewer::InteractiveImageHandler::run | ( | osg::Object * | object,
|  | osg::Object * | data )

inline virtual

NodeCallback overrides the Callback::run() method to adapt it the old style NodeCallback::operator()(Node* node, NodeVisitor* nv) method.

Reimplemented from osgGA::EventHandler.

References osg::Callback::run().

## Member Data Documentation

## _camera

osg::observer_ptr<osg::Camera> osgViewer::InteractiveImageHandler::_camera

protected

## _fullscreen

bool osgViewer::InteractiveImageHandler::_fullscreen

protected

Referenced by InteractiveImageHandler(), and InteractiveImageHandler().

## _image

osg::observer_ptr<osg::Image> osgViewer::InteractiveImageHandler::_image

protected

## _texture

osg::observer_ptr<osg::Texture2D> osgViewer::InteractiveImageHandler::_texture

protected

The documentation for this class was generated from the following file:

- osgViewer/ViewerEventHandlers